function tpApiRequestAsync(relativeUrl, method, datatype, contenttype, body, callback, retries) {

    //tpApiRequest gets 4 more tries if the initial request failed, since
    //thinkproject seems to sometimes throw 404's, but on subsequent runs it succeeds
    //this usually occurs when trying to download JSON files from viewpoints
    if (retries === undefined) {
        retries = 2;
    }

    var url;
    if (stringStartsWithValue(relativeUrl, 'https://')) {
        url = relativeUrl;
    } else {
        url = _config.tpApiUrl + relativeUrl;
    }

    var settings = {
        //TIMS EDITING
        async: true, 
        //TIMS EDITING
        url: url,
        type: method,
        dataType: datatype,      // 'json', 'text' ...
        crossDomain: true,        // 20.09.2019
        //TIMS EDITING
        contentType: contenttype,
        
        //TIMS EDITING
        beforeSend: function(req) {
            req.setRequestHeader('Content-Type', contenttype);
            req.setRequestHeader('X-TP-APPLICATION-CODE', _config.appKey);
            req.setRequestHeader('x-tp-oidc-auth', '1');
            if(_token) {
                req.setRequestHeader('Authorization', 'Bearer ' + _token);
            }
        },
        success: callback,
        error: function(error) {
            console.log('Url: ' + url + '\nError: ' + JSON.stringify(error));
            //console.log(JSON.stringify(settings));
            //debugPrint('Url: ' + url + '\nError: ' + JSON.stringify(error));

            //try again if request was not working due to a 404 not found
            //if (error.error.code === 404 && retries > 0) {

            if (retries > 0) {
                //debugPrint('Retries: ' + retries);
                //console.log('Retries: ' + retries);
                tpApiRequest(relativeUrl, method, datatype, contenttype, body, callback, --retries);
            } else {
                if(relativeUrl === '/auth'){
                    ////console.log('giving up, authentication FAILED');
                    hideProgress();
                    debugPrint('Error! Authentication failed.' );
                } else{
                    debugPrint('Error while getting data!' );
                }
            }
        }
    };
    if (method === "GET"){
        settings.cache = false;
    }
    if (method === "POST" || method === "PUT") {
        settings.data = body;
    }
   // console.log(JSON.stringify(settings));
    //console.log("settings: " + JSON.stringify(settings));
    $.ajax(settings);
}

function tpApiRequest(relativeUrl, method, datatype, contenttype, body, callback, retries) {

    //tpApiRequest gets 4 more tries if the initial request failed, since
    //thinkproject seems to sometimes throw 404's, but on subsequent runs it succeeds
    //this usually occurs when trying to download JSON files from viewpoints
    if (retries === undefined) {
        retries = 0;
    }

    var url;
    if (stringStartsWithValue(relativeUrl, 'https://')) 
    {
        url = relativeUrl;
    } 
    else 
    {
        url = _config.tpApiUrl + relativeUrl;
    }

    var settings = 
    {
        //TIMS EDITING
         async: false, 
        //TIMS EDITING
        url: url,
        type: method,
        dataType: datatype,      // 'json', 'text' ...
        crossDomain: true,        // 20.09.2019
        contentType: contenttype,
        headers: 
        {
            "x-tp-oidc-auth": "1",
        },
        beforeSend: function(req) 
        {
            req.setRequestHeader('Content-Type', contenttype);
            req.setRequestHeader('X-TP-APPLICATION-CODE', _config.appKey);
            req.setRequestHeader('x-tp-oidc-auth', '1');
            if(_token) {
                req.setRequestHeader('Authorization', 'Bearer ' + _token);
            }
        },
        success: callback,
        error: function(error) 
        {
            console.log('Url: ' + url + '\nError: ' + JSON.stringify(error));
            //console.log(JSON.stringify(settings));
            //debugPrint('Url: ' + url + '\nError: ' + JSON.stringify(error));

            //try again if request was not working due to a 404 not found
            //if (error.error.code === 404 && retries > 0) {

            if (retries > 0) {
                //debugPrint('Retries: ' + retries);
                console.log('Retries: ' + retries);
                tpApiRequest(relativeUrl, method, datatype, contenttype, body, callback, --retries);
            } else {
                if(relativeUrl === '/auth'){
                    ////console.log('giving up, authentication FAILED');
                    hideProgress();
                    debugPrint('Error! Authentication failed.' );
                } else if (_callFromGetTpViewpoints){
                    hideProgress();
                    debugPrint('Error while getting data! Viewpoints are not downloaded.' );
                    _callFromGetTpViewpoints = false;
                    if(_callFromDownloadProject){
                      downloadPMsAndCMsNew();
                    }
                } else if (relativeUrl.indexOf('/send_wait') != -1){
                    alert('Error while sending data!');
                    desiteMD.hideProgress();
                }else{
                    console.log('Error while getting data!' );
                    hideProgress();
                    debugPrint('Error while getting data!' );
                }
            }
        }
    };
    if (method === "GET"){
        settings.cache = false;
    }
    if (method === "POST" || method === "PUT") {
        settings.data = body;
    }
    //console.log(JSON.stringify(settings));
    //console.log("settungs: " + JSON.stringify(settings));
    $.ajax(settings);
}

            
// Perform a thinkproject BIM REST request 

function tpBimApiRequest(relativeUrl, method, contentType, body, callback, tpBimApiRequestRetries) 
{
    //console.log('\nBEGIN tpBimApiRequest\n');
    //console.log(callback);
    if (tpBimApiRequestRetries === undefined) 
    {
        tpBimApiRequestRetries = 0;
    }
    //var url = 'https://www30.thinkproject.com/bimapp/maps/create_document/';
    var url = _config.tpBimApiUrl + relativeUrl;
    console.log(url);

    var settings = {
        async: false,
        url: url,
        type: method,
        dataType: "json",
        contentType: 'application/json',
        headers: {
            "x-tp-oidc-auth": "1",
        },
        beforeSend: function(req) {
            req.setRequestHeader('Content-Type', contentType);
            req.setRequestHeader('Accept', 'application/json');
            req.setRequestHeader('Instid', _config.instance);
            req.setRequestHeader('Project', _config.project);
            req.setRequestHeader('TPAuth', 'Bearer ' + _token);
            req.setRequestHeader('X-tpHost', _config.host);
            req.setRequestHeader('X-TP-APPLICATION-CODE', _config.appKey);
            req.setRequestHeader('X-TP-OIDC-AUTH','1');
        },
        success: callback,
        error: function(error) {
            console.log('Url: ' + url + '\nError: ' + JSON.stringify(error));
            if (tpBimApiRequestRetries > 0) {
                //debugPrint('Retries: ' + tpBimApiRequestRetries);
                //console.log('Retries: ' + tpBimApiRequestRetries);
                tpBimApiRequest(relativeUrl, method, contentType, body, callback, --tpBimApiRequestRetries);
            } 
            else {
                //console.log('Giving up, posting FAILED.');
                hideProgress();
                // alert('Error! Staus: ' + error.statusText + '. Posting failed.' );
            }
        }
    };
    // console.log(JSON.stringify(settings));
    if (method === "GET"){
        settings.cache = false;
    }
    if(method === "POST") 
    {
        settings.data = body;
    }
    $.ajax(settings);
}	